#!/bin/sh

SOURCE_PATH="/mnt/usb"

if [ ! -d /usr/data/blackbox ]
then
	exit 1
fi

if [ ! -d "$SOURCE_PATH"/blackbox ]
then
	exit 1
fi

aplay -c 1 -r 16000 -f S16_LE /usr/SNDDATA/SND_BLACKBOX_LOADING_START.snd

count=0

while [ true ]
do
	if [ ! -d "$SOURCE_PATH"/blackbox/"$count" ]
	then
		mkdir "$SOURCE_PATH"/blackbox/"$count"
		cp /usr/data/blackbox/* "$SOURCE_PATH"/blackbox/"$count"
		
		if [ ! $? == 0 ]
		then
			sync
			aplay -c 1 -r 16000 -f S16_LE /usr/SNDDATA/SND_BLACKBOX_FAIL.snd
			exit 1
		fi
		
		sync
		
		if [ ! $? == 0 ]
		then
			aplay -c 1 -r 16000 -f S16_LE /usr/SNDDATA/SND_BLACKBOX_FAIL.snd
			exit 1
		fi
		
		break;
	else
		count=$((count+1))
	fi

	if [[ $count -gt 65535 ]]
	then
		echo "Too many folders exist, Quit"
		aplay -c 1 -r 16000 -f S16_LE /usr/SNDDATA/SND_BLACKBOX_FULL.snd
		exit 1
	fi
done

aplay -c 1 -r 16000 -f S16_LE /usr/SNDDATA/SND_BLACKBOX_LOADING_END.snd

exit 0