#!/bin/sh

REPOSITORY="http://val.lge.com/hact/svn/IT_MI_RK5/trunk/src"
REVISION=13865

FIRMWARE_FILE_NAME="hit_firmware"
#FILE_SERVER_PATH="http://www.lgservice.co.kr/upload/roboking"
FILE_SERVER_PATH="ftp://roboking@192.168.0.5"

ERROR_TEXT="Error :" 

Remove_File() {
	if [ -f /usr/tmp/"$FIRMWARE_FILE_NAME".md5 ]
	then
	rm /usr/tmp/"$FIRMWARE_FILE_NAME".md5
	fi
	
	if [ -f /usr/tmp/"$FIRMWARE_FILE_NAME".tar ]
	then
	rm /usr/tmp/"$FIRMWARE_FILE_NAME".tar
	fi
	
	if [ -f /usr/tmp/"$FIRMWARE_FILE_NAME".tar.gz ]
	then
	rm /usr/tmp/"$FIRMWARE_FILE_NAME".tar.gz
	fi
	
	return 0
}

Check_File() {
	if [ ! -f /usr/tmp/"$FIRMWARE_FILE_NAME".md5 ]
	then
	return 1
	fi
	
	if [ ! -f /usr/tmp/"$FIRMWARE_FILE_NAME".tar.gz ]
	then
	return 2
	fi
	
	cd /usr/tmp/
	busybox md5sum -c "$FIRMWARE_FILE_NAME".md5

	if [ $? -ne 0 ]
	then
	echo "$ERROR_TEXT Checksum error"
	return 3
	fi
	
	return 0	
}

Download_File() {
	cd /usr/tmp
	busybox wget -c "$FILE_SERVER_PATH"/"$FIRMWARE_FILE_NAME".sh
	
	if [ ! -f "$FIRMWARE_FILE_NAME".sh ]
	then
	echo "$ERROR_TEXT Can't download script file."
	return 1
	fi

	chmod 775 "$FIRMWARE_FILE_NAME".sh
	
	./"$FIRMWARE_FILE_NAME".sh CMPVER "$REVISION" "$REPOSITORY"
    
	if [ $? -ne 0 ]
	then
	rm "$FIRMWARE_FILE_NAME".sh
	return 1
	fi
	    
	busybox wget -c "$FILE_SERVER_PATH"/"$FIRMWARE_FILE_NAME".md5
	
	if [ ! -f "$FIRMWARE_FILE_NAME".md5 ]
	then
	echo "$ERROR_TEXT Can't download checksum file."
	return 1
	fi
	
	busybox wget -c "$FILE_SERVER_PATH"/"$FIRMWARE_FILE_NAME".tar.gz
	
	if [ ! -f "$FIRMWARE_FILE_NAME".tar.gz ]
	then
	echo "$ERROR_TEXT Can't download firwmare file."
	return 1
	fi
	
	busybox md5sum -c "$FIRMWARE_FILE_NAME".md5
	
	if [ $? -ne 0 ]
	then
	echo "$ERROR_TEXT Checksum error"
	return 1
	fi
	
	return 0
}

Install_File() {
	cd /usr/tmp
	echo "UPDATE#1 ***** Do FIRMWARE UPDATE NOW *****"
	touch /usr/NOW_INSTALL.tmp

	if [ ! -f "$FIRMWARE_FILE_NAME".tar.gz ]
	then
		echo "UPDATE ***** $ERROR_TEXT firmare file is not exist *****"
		return 1
	fi
	
	echo "UPDATE#2 ***** gunzip FIRMWARE FILE NOW *****"
	
	gunzip -f "$FIRMWARE_FILE_NAME".tar.gz
	
	if [ $? -ne 0 ]
	then
		echo "UPDATE ***** $ERROR_TEXT Can't unzip firmare file 1 *****"
		return 1
	fi
	
	if [ ! -f "$FIRMWARE_FILE_NAME".tar ]
	then
		echo "UPDATE ***** $ERROR_TEXT Can't unzip firmare file 2 *****"
	return 1
	fi
	
#Insert codes for remove files here!!
	if [ -f /usr/SLAM.xml ]
	then
		cp /usr/SLAM.xml /usr/SLAM.bak
	fi
	if [ -f /usr/rcfg/SLAM.xml ]
	then
		cp /usr/rcfg/SLAM.xml /usr/SLAM.bak
	fi	
	
	rm /usr/SNDDATA/SND_HOMING_CLEANING_END_RETURN_START.snd
	rm /usr/SNDDATA/SND_HOMING_RETURN_START_FAIL.snd
	rm /usr/SNDDATA/SND_BATTERY_CHECK.snd
	rm /usr/SNDDATA/SND_KIDNAP_RECOVERED_CONTINUE.snd
	rm /usr/SNDDATA/SND_KIDNAP_RECOVERED_BEGIN_HOMING.snd
	rm /usr/SNDDATA/SND_KIDNAP_RECOVERED_RETURN_START.snd
	rm /usr/rk4/rk4_cc.axf
	rm /data/slam/*
	rm /usr/rp*
	rm /usr/*.xml
	rm /usr/*.axf
	rm /usr/*.sh
#Insert codes for remove files here!!

	echo "UPDATE#3 ***** install file *****"

	tar xvf "$FIRMWARE_FILE_NAME".tar
	
	if [ $? -ne 0 ]
	then
		echo "UPDATE ***** $ERROR_TEXT Can't install file *****"
		return 1
	fi
	
	echo "UPDATE#4 ***** Remove downloaded files *****"
	
	rm "$FIRMWARE_FILE_NAME".tar
	rm "$FIRMWARE_FILE_NAME".md5
	
	echo "UPDATE#5 ***** Copy new files *****"
	cp -r * /usr
	
	#temp.
	cp /usr/SLAM.bak /usr/rcfg/SLAM.xml
	touch /usr/rcfg/cameracal.cfg
	#temp.

	if [ $? -ne 0 ]
	then
		echo "UPDATE ***** $ERROR_TEXT Can't copy new file *****"
		rm -r *
		return 1
	fi
	
	mv /usr/tmp/"$FIRMWARE_FILE_NAME".sh /usr/rscript/downloader.sh
	rm -r *
	rm /usr/NOW_INSTALL.tmp

#Change mode for excuting here!!
	chmod 775 /usr/rbin/*
	chmod 775 /usr/rscript/*
	chmod 775 /usr/etc/rc.*
	mkdir /usr/data
	mkdir /usr/data/slam
	mkdir /usr/data/blackbox
	chmod 775 /usr/data
	chmod 775 /usr/data/slam
	chmod 775 /usr/data/blackbox
	rm /usr/SNDDATA/SND_DEBUG_*.snd
	sync
#Change mode for excuting here!!	

	return 0
}

if [ -z "$1" ]
then
	echo "$ERROR_TEXT Parameter is not exist"
	exit 1
elif [ "$1" = "REMOVE" ]
then
	Remove_File
exit 0

elif [ "$1" = "INSTALL" ]
then

	if [ -f /usr/"$FIRMWARE_FILE_NAME".sh ]
	then
		cp /usr/"$FIRMWARE_FILE_NAME".sh /usr/tmp/
	fi
	
	if [ -f /usr/"$FIRMWARE_FILE_NAME".md5 ]
	then
		mv /usr/"$FIRMWARE_FILE_NAME".md5 /usr/tmp/
	fi
	
	if [ -f /usr/"$FIRMWARE_FILE_NAME".tar.gz ]
	then
		mv /usr/"$FIRMWARE_FILE_NAME".tar.gz /usr/tmp/
	fi
	
	sync

	Install_File
exit $?

elif [ "$1" = "CMPVER" ]
then
	if [ -f /usr/NOW_INSTALL.tmp ]
	then
		echo "FIRMWARE UPDATE : Previous firmware update fail"
		exit 0
	fi

	if [ "$2" -ge "$REVISION" ]
	then
		echo "FIRMWARE UPDATE : don't necessary firmware update"
		exit 1
	fi
	
	if [ "$3" != "$REPOSITORY" ]
	then
		echo "FIRMWARE UPDATE : not equal Repository"
		exit 1
	fi
    
exit 0

elif [ "$1" = "CHECK" ]
then
	if [ -f /usr/NOW_INSTALL.tmp ]
	then
		echo "FIRMWARE UPDATE : Previous firmware update fail"
		exit 0
	fi

	if [ "$2" -ge "$REVISION" ]
	then
		echo "$ERROR_TEXT don't necessary firmware update"
		exit 1
	fi

	if [ "$3" != "$REPOSITORY" ]
	then
		echo "$ERROR_TEXT not equal Repository"
		exit 1
	fi

	Check_File
exit $?

elif [ "$1" = "DOWNLOAD" ]
then

if [ ! -z "$2" ]
then
	FILE_SERVER_PATH=$2
	echo "File Server Path : $FILE_SERVER_PATH"
fi

	Download_File

	exit $?
fi

echo "$ERROR_TEXT Parameter is not exist"

exit 1:
