#!/bin/sh

# Script zur Reparatur bei fehlerhafter /usr/etc/rc.local
# und fehlenden Dateirechten zur Ausführung der Scripte.
#
# Das Script nur zur Reparatur bei nicht bootendem Homebot 3.0 verwenden
#
# *************************************************************
# *                                                           *
# *  Die Anwendung des Scripts erfolgt auf eigene Gefahr !!!  *
# *                                                           *
# *************************************************************


# Zuerst die beiden Partitionen mounten
ubiattach -m 3
ubiattach -m 4
mount -a

# Etwas warten, damit mount genügend Zeit hat,
# sowie die Nervoesität und Spannung steigt. :-)

sleep 20
sync

# Nun sollte der normale Zugriff möglich sein.

SOURCE_PATH="/mnt/usb"

# Test ob Zugriff möglich ist

ls -lR /usr > "${SOURCE_PATH}"/usr-Dateien.txt

# Test: Existiert auf dem Homebot die rc.local
if [ -f /usr/etc/rc.local ]; then

    # Sichere zuerst die fehlerhafte rc.local vom Homebot
    cp /usr/etc/rc.local "$SOURCE_PATH"/fehlerhafte_rc.local

fi

if [ -f "$SOURCE_PATH"/rc.local ]; then

    # Die rc.local ist auf dem Stick vorhanden.

    # Sicherstellen das wir die Datei auf dem Homebot überschreiben können
    chmod 777 /usr/etc/rc.local

    # Also nun Original rc.local in den Homebot kopieren.
    cp "$SOURCE_PATH"/rc.local /usr/etc/rc.local

    # Sicherheitshalber die Datei als ausführbar kennzeichnen. 
    chmod 755 /usr/etc/rc.local

fi

sync

# Sicherstellen das wir die Dateien in rscript überschreiben können
chmod 777 /usr/rscript/* 

Nun die Dateien von V 13865 kopieren
cp "$SOURCE_PATH"/adhoc.sh /usr/rscript
cp "$SOURCE_PATH"/autoconn.sh /usr/rscript
cp "$SOURCE_PATH"/blackbox.sh /usr/rscript
cp "$SOURCE_PATH"/downloader.sh /usr/rscript
cp "$SOURCE_PATH"/log_end.sh /usr/rscript
cp "$SOURCE_PATH"/log_start.sh /usr/rscript
cp "$SOURCE_PATH"/rpcon.sh /usr/rscript
cp "$SOURCE_PATH"/rpkill.sh /usr/rscript
cp "$SOURCE_PATH"/run_hit.sh /usr/rscript
cp "$SOURCE_PATH"/spacecheck.sh /usr/rscript
cp "$SOURCE_PATH"/updater.sh /usr/rscript
cp "$SOURCE_PATH"/voice_jig_conn.sh /usr/rscript
cp "$SOURCE_PATH"/wificonn.sh /usr/rscript
cp "$SOURCE_PATH"/wps_start.sh /usr/rscript

  # Nun noch alle Scripte in /usr/rscript auf ausführbar
chmod 755 /usr/rscript/* 

  # Für eine evtl weitere Fehlersuche noch eine Liste mit
  # den Dateien aus den drei Verzeichnissen
  #  /etc
  #  /usr/etc
  #  /usr/rscript
  # erstellt.

  echo " ***  Verzeichnisbaum  /etc/  *** " > "$SOURCE_PATH"/Dateiliste.txt
  ls -lR /etc >> "$SOURCE_PATH"/Dateiliste.txt

  echo " " >> "$SOURCE_PATH"/Dateiliste.txt
  echo " ***  Verzeichnisbaum  /usr/etc/  *** " >> "$SOURCE_PATH"/Dateiliste.txt
  ls -lR /usr/etc >> "$SOURCE_PATH"/Dateiliste.txt

  echo " " >> "$SOURCE_PATH"/Dateiliste.txt
  echo " ***  Verzeichnisbaum  /usr/rscript/  *** " >> "$SOURCE_PATH"/Dateiliste.txt
  ls -lR /usr/rscript >> "$SOURCE_PATH"/Dateiliste.txt
  
sync

# Habe fertig. Viel Glück!
# Der Bootvorgang wird fortgesetzt.

exit 0

