#!/bin/sh
if [ ! -f /usr/rcfg/cameracal.cfg ]
then
	if [ -f /usr/rcfg/cc_param_Huentek_1-9inch.cfg ]
	then
		echo "Calibration 1/9 inch Camera"
		rkhit_cc.axf camera /usr/rcfg/ cc_param_Huentek_1-9inch.cfg &
	else
		echo "Calibration 1/4 inch Camera"
		rkhit_cc.axf camera /usr/rcfg/ cc_param_Huentek.cfg &
	fi
	exit 0
fi

config_param="config.xml"
getpartnum="0"
run_rpjig=$1

if [ -f /usr/rcfg/Name.dat ]
then
getpartnum=`cat /usr/rcfg/Name.dat`
fi

if [ ! -f /usr/rcfg/SLAM.xml ]
then
	cp /usr/SLAM.xml /usr/rcfg/SLAM.xml
fi

sleep 1
if [ $getpartnum = "EBR74755203" ]
then

	if [ "$2" == "LOGGING_ON" ]
	then
		config_param="config_voice_d.xml"
		rpmain.axf /vision /usr/rcfg/"$config_param" /usr/rcfg /Playback /broker /collector_vision /time /App /Keyword /Motion /Navi /Planner /Input /Camera /SLAM /Event /BlackBox /Sound /SSL /VR /LS &
	else
		config_param="config_voice.xml"
		rpmain.axf /vision /usr/rcfg/"$config_param" /usr/rcfg /Playback /broker /collector_vision /time /App /Keyword /Motion /Navi /Planner /Input /Camera /SLAM /Event /BlackBox /Sound /SSL /VR &
	fi

elif [ "$1" = "SOFTAP_MODE" ]
then
	config_param="config_local.xml"
	rpmain.axf /vision /usr/rcfg/"$config_param" /usr/rcfg /broker /collector_vision /time /App /Motion /Navi /Planner /Input /Camera /SLAM /Playback /Event /BlackBox /SmartControl /SmartData &
	
	if [[ "$2" -eq 2 ]]
	then
		run_rpjig="WIFI_ATTACHED"
	fi
else
	rpmain.axf /vision /usr/rcfg/"$config_param" /usr/rcfg /broker /collector_vision /time /App /Motion /Navi /Planner /Input /Camera /SLAM /Playback /Event /BlackBox &
fi

sleep 1
log_start.sh "$config_param" &

if [ "$run_rpjig" == "WIFI_ATTACHED" ]
then
sleep 1
	rpjig.axf /vision /usr/rcfg/"$config_param" /usr/rcfg /JigCameraTest /Jig_vision &
fi
