#!/bin/sh
#RECENT COMMITTED DATE : 2014/11/10 13:58:26

echo "=============run updater.sh============="
REPOSITORY="http://val.lge.com/hact/svn/IT_MI_RK5/trunk/src"
REVISION=13865

FIRMWARE_FILE_NAME="hit_firmware"
MAINBOARD_FIRMWARE="/usr/hit_main.bin"
UPDATE_FILE_NAME="firmwareupdate.dat"
BACKUP_FILE_NAME="firmwarebackup.dat"
UPDATE_FLAG_FILE_NAME="updateflag"
do_firmware_update=0

Check_Exist_File() {
	if [ ! -f /usr/tmp/"$FIRMWARE_FILE_NAME".tar.gz ]
	then
		return 1
	fi
	
	if [ ! -f /usr/tmp/"$FIRMWARE_FILE_NAME".md5 ]
	then
		return 2
	fi
	
	if [ ! -f /usr/tmp/"$FIRMWARE_FILE_NAME".sh ]
	then
		return 3
	fi
	
	return 0
}

if [ "$1" = "WIFI_ATTACHED" ]
then
	downloader.sh DOWNLOAD

	if [ $? -eq 0 ]
	then
	aplay -c 1 -r 16000 -f S16_LE /usr/SNDDATA/SND_UPDATEFILE_DOWNLOADED.snd
	fi
fi

if [ -d /mnt/usb/update ]
then
	cp /mnt/usb/update/hit_firmware.* /usr/tmp
fi

Check_Exist_File

if [ $? -eq 0 ]
then
	/usr/tmp/"$FIRMWARE_FILE_NAME".sh CHECK "$REVISION" "$REPOSITORY"

	if [ $? -eq 0 ]
	then
		do_firmware_update=1
		aplay -c 1 -r 16000 -f S16_LE /usr/SNDDATA/SND_NOTICE_UPDATE_START.snd
		/usr/tmp/"$FIRMWARE_FILE_NAME".sh INSTALL
		
		if [ $? -ne 0 ]
		then
			do_firmware_update=0
			aplay -c 1 -r 16000 -f S16_LE /usr/SNDDATA/SND_NOTICE_UPDATE_FAIL.snd
		fi
	fi
fi

rm /usr/"$FIRMWARE_FILE_NAME".tar.gz
rm /usr/"$FIRMWARE_FILE_NAME".md5
rm /usr/"$FIRMWARE_FILE_NAME".sh
rm /usr/tmp/"$FIRMWARE_FILE_NAME".tar.gz
rm /usr/tmp/"$FIRMWARE_FILE_NAME".md5
rm /usr/tmp/"$FIRMWARE_FILE_NAME".sh
#rm /usr/SNDDATA/SND_DEBUG*

if [ -d /mnt/usb/update ]
then
	echo "Unmount USB Memory"
	cd /usr
	umount /mnt/usb
fi

#Update Flag File   
if [ -f /usr/data/"$UPDATE_FLAG_FILE_NAME" ]
then
    echo "Update Flag File Found! Start Update"
	if [ -f /usr/data/"$UPDATE_FILE_NAME" ]
	then
		/usr/data/update.axf /usr/data/"$UPDATE_FILE_NAME"
		if [ $? > 5 ]
		then
			echo "Update Failed! Start Restore"
			/usr/data/update.axf /usr/data/"$BACKUP_FILE_NAME"
		elif [ $? -eq 0 ]
		then
			rm /usr/data/"$BACKUP_FILE_NAME"
			cp /usr/data/"$UPDATE_FILE_NAME" /usr/data/"$BACKUP_FILE_NAME"
		fi
		rm /usr/data/"$UPDATE_FILE_NAME"
		rm /usr/data/"$UPDATE_FLAG_FILE_NAME"
		rm /usr/data/update.axf
		exit 0
	fi

	rm /usr/data/"$UPDATE_FLAG_FILE_NAME"
	rm /usr/data/update.axf
fi


if [ -f "$MAINBOARD_FIRMWARE" ]
then
	if [ "$do_firmware_update" -ne 1 ]
	then
		aplay -c 1 -r 16000 -f S16_LE /usr/SNDDATA/SND_NOTICE_UPDATE_START.snd
	fi
	
	HIT_Startup.axf "$MAINBOARD_FIRMWARE"

	if [ $? -ne 0 ]
	then
		aplay -c 1 -r 16000 -f S16_LE /usr/SNDDATA/SND_NOTICE_UPDATE_FAIL.snd
	else
		rm "$MAINBOARD_FIRMWARE"
		
		aplay -c 1 -r 16000 -f S16_LE /usr/SNDDATA/SND_NOTICE_UPDATE_END.snd
	fi
else
	if [ "$do_firmware_update" -eq 1 ]
	then
		aplay -c 1 -r 16000 -f S16_LE /usr/SNDDATA/SND_NOTICE_UPDATE_END.snd
	fi

	HIT_Startup.axf
fi
echo "=============end updater.sh============="