#!/bin/sh
# wificonn.sh, Wifi Connection
# if the Wifi Dongle Found, Connect Wifi

WIFIDONGLE_ATTATCHED=0
WIFI_DEVICE_NAME="ra0"
WIFI_ESSID=$2
WIFI_SET_IP=$3
WPS_MODE=$1
SOFTAP_MODE=$4

if [[ WIFIDONGLE_ATTACHED -eq 0 ]]
then
	modprobe rt3070sta
	if [[ `ifconfig -a|grep ra0` == "" ]]
	then
		echo "Cannot Find rt3070sta  Wifi Dongle"
		rmmod rt3070sta
		
	else
		WIFIDONGLE_ATTACHED=1
		echo "rt3070sta CONNECTED"
	fi
fi

if [[ WIFIDONGLE_ATTACHED -eq 0 ]]
then
	modprobe rt5370sta
	if [[ `ifconfig -a|grep ra0` == "" ]]
	then
		echo "Cannot Find rt5370sta Wifi Dongle"
		rmmod rt5370sta
		
	else
		WIFIDONGLE_ATTACHED=1
		echo "rt5370sta CONNECTED"
	fi
fi

if [[ WIFIDONGLE_ATTACHED -eq 0 ]]
then
	insmod /usr/etc/rt3370sta.ko
	if [[ `ifconfig -a|grep ra0` == "" ]]
	then
		echo "Cannot Find rt3370sta Wifi Dongle"
		rmmod rt3370sta
		
	else
		WIFIDONGLE_ATTACHED=1
		echo "rt3370sta CONNECTED"
	fi
fi

if [[ WIFIDONGLE_ATTACHED -eq 0 ]]
then
	#modprobe 8192cu
	insmod /usr/etc/8192cu.ko
	if [[ `ifconfig -a|grep wlan0` == "" ]]
	then
		echo "Cannot Find 8192cu Wifi Dongle"
		rmmod 8192cu
	else
		echo "8192cu CONNECTED"
		WIFIDONGLE_ATTACHED=1
		WIFI_DEVICE_NAME="wlan0"
	fi
fi

if [[ WIFIDONGLE_ATTACHED -eq 1 ]]
then
	echo "$WIFI_SET_IP" > /usr/tmp/wifiIP.cfg
	echo "$WIFI_DEVICE_NAME" > /usr/tmp/wifiDevice.cfg
	if [[ "$WPS_MODE" == "WPS_ON" ]]
	then
		ifconfig "$WIFI_DEVICE_NAME" up
		dropbear
		/usr/rscript/autoconn.sh &
		exit 0
	fi
	
	if [[ ! "$SOFTAP_MODE" -eq 1 ]]
	then
		ifconfig "$WIFI_DEVICE_NAME" up
		iwconfig "$WIFI_DEVICE_NAME" essid "$WIFI_ESSID"
	
		count=0
		while [ true ]
			do			
				if [[ `iwconfig 2>&1| grep 'ESSID'|busybox awk  '{print $4}'| busybox awk -F: '{print $2}'` != "" ]]
				then
					echo "success connect to $WIFI_ESSID"
					break;
				else
					echo "Try to find $WIFI_ESSID"
					count=$((count+1))
					sleep 1
				fi
			
			if [[ "$count"  > 5 ]]
			then
				echo "Cannot find $WIFI_ESSID in $count times"
				exit 0
			fi
		done
	
		if [ "$WIFI_SET_IP" == "" ]
		then
			udhcpc -i "$WIFI_DEVICE_NAME" -n -t 5 -q
			cur_state=$?
		else
			ifconfig "$WIFI_DEVICE_NAME" "$WIFI_SET_IP" up
			cur_state=$?
		fi
	
    		if [ "$cur_state" == 0 ]
		then
			echo "IP Setting Success"
			exit 0
		else
			echo "IP Setting Fail"
			exit 0
		fi
	else
		#if [ ! -e /usr/rcfg/APSETOK.cfg ]
		#then
		#	/usr/rscript/setAPEnV.sh
		#fi
		
		/usr/rscript/setAPmode.sh 
		dropbear
		exit 1
	fi
fi
exit 1
